/************************************************************************************
iPhone Communication RT-Component
Copyright (c) 2010, Nagoya Institute of Technology
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD lisence.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/
import java.util.*;
import javax.vecmath.*;

public class OSCIPhoneController implements Runnable {

	public int recievePort=33333;

	public boolean recieveFlag=false;

	char[] testChar = null;
	byte[] testByte = null;
	ByteUtil myByte = new ByteUtil();

	public int buttonStatus=0;

	public int groundAngle = 0;
	public int angleX = 0;
	public int angleY = 0;
	public int angleZ = 0;
	public int timerCounter=0;
	public String runWayPointSt="";
	public Point2d[] wayPoint=null;
	public int compass=0;
	
	public Point3d robotPosition=null;

	
	public void run(){
		System.out.println("Recieving thread start!");

		PacketReciever2 myReciever = new PacketReciever2();
		myReciever.PORT=recievePort;

		myReciever.init();

		while(true){
			try {
				Thread.sleep(5);
			}catch(Exception xe){
					xe.getStackTrace();
			}
			
			if(recieveFlag){
//				System.out.println("reciveStart");
				myReciever.PacketReceiver();
//				System.out.println("reciveData:"+myReciever.message);
				testByte = myReciever.data;
				if(testByte !=null){
					testChar = new char[testByte.length];
					for(int i=0;i<testByte.length;i++){
						int test = (int)(testByte[i] & 0xff);
						testChar[i]=(char)test;
					}

					if(testChar.length>5){
			            String checkerSt = new String( testChar, 0, 5 );
			            if(checkerSt.equals("count")){
							if(testChar.length ==128){
								buttonStatus = myByte.getint(testByte, 12);
							}
			            }

			            if(checkerSt.equals("angle")){
							if(testChar.length ==128){
								groundAngle = myByte.getint(testByte, 12);
							}
			            }
			          if(checkerSt.equals("anglX")){
							if(testChar.length ==128){
								angleX = myByte.getint(testByte, 12);
							}
			            }
			          if(checkerSt.equals("anglY")){
							if(testChar.length ==128){
								angleY = myByte.getint(testByte, 12);
							}
			            }
			          if(checkerSt.equals("anglZ")){
							if(testChar.length ==128){
								angleZ = myByte.getint(testByte, 12);
							}
			            }
			          if(checkerSt.equals("timer")){
							if(testChar.length ==128){
								timerCounter = myByte.getint(testByte, 12);
							}
			            }
			          if(checkerSt.equals("compa")){
							if(testChar.length ==128){
								compass = myByte.getint(testByte, 12);
							}
			            }
			          if(checkerSt.equals("runWP")){
							if(testChar.length ==128){
								runWayPointSt = myReciever.message;
								System.out.println("runWP:"+runWayPointSt);
								//CSV
								StringTokenizer st=new StringTokenizer(runWayPointSt,",");
								int wayLength=0;
								String hoge="";
								while(st.hasMoreTokens()){
									hoge=st.nextToken().toString();
									wayLength++;
								}								
								System.out.println("wayLength: "+wayLength);
								wayLength=(wayLength-3)/2;
								System.out.println("wayLength2: "+wayLength);
								
								st=new StringTokenizer(runWayPointSt,",");
								int i=0;
								int j=0;
								int wayX=0;
								int wayY=0;
								wayPoint=new Point2d[wayLength];
								
								while(st.hasMoreTokens()){
									if(i<2){
										hoge=st.nextToken().toString();
									}else if(i<wayLength*2+2){
										if(i%2==0){
											wayX=Integer.parseInt(st.nextToken().toString());
										}else if(i%2==1){
											wayY=-Integer.parseInt(st.nextToken().toString());
											wayPoint[j]=new Point2d(wayX,wayY);
											j++;
										}
									}else{
										hoge=st.nextToken().toString();
									}
									i++;
								}

								for(int k=0;k<wayPoint.length;k++){
									System.out.println("wayPoint["+k+"]:"+wayPoint[k].x+","+wayPoint[k].y);
								}
								
								if(robotPosition !=null){
									wayPointUpdate(robotPosition);
								}
								for(int k=0;k<wayPoint.length;k++){
									System.out.println("wayPoint2["+k+"]:"+wayPoint[k].x+","+wayPoint[k].y);
								}
							}
			            }

					}
				}
			}
		}
	}
	
	public boolean wayPointUpdate(Point3d beforeRobotPosition){
		
		for(int i=0;i<wayPoint.length;i++){
			//グローバル座標に変換
			//ロボット座標系からグローバルマップ系に変換
			double x=wayPoint[i].x;
			double y=wayPoint[i].y;
			//回転行列
			Matrix3d Rz = new Matrix3d(); // マトリクスを作成
			Rz.rotZ(beforeRobotPosition.z); // 回転マトリクスをセット
			//並進ベクトル
			Vector3d transV = new Vector3d(beforeRobotPosition.x, beforeRobotPosition.y, 0);
			//同次変換行列の作成
			Matrix4d transAll = new Matrix4d();
			transAll.set(Rz, transV, 1);
			Vector4d v = new Vector4d(x, y, 0, 1); // ベクトルの初期値
			transAll.transform(v);	// TransAll を v に作用させる
			wayPoint[i] = new Point2d(v.x, v.y);
		}

		return true;
	}
}
