/************************************************************************************
iPhone Communication RT-Component
Copyright (c) 2010, Nagoya Institute of Technology
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD lisence.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/
// -*- Java -*-
/*!
 * @file iPhoneComm.java
 * @date $Date$
 *
 * $Id$
 */

import jp.go.aist.rtm.RTC.Manager;
import jp.go.aist.rtm.RTC.RTObject_impl;
import jp.go.aist.rtm.RTC.RtcDeleteFunc;
import jp.go.aist.rtm.RTC.RtcNewFunc;
import jp.go.aist.rtm.RTC.RegisterModuleFunc;
import jp.go.aist.rtm.RTC.util.Properties;

/*!
 * @class iPhoneComm
 * @brief Communicator for iPhone
 */
public class iPhoneComm implements RtcNewFunc, RtcDeleteFunc, RegisterModuleFunc {

//  Module specification
//  <rtc-template block="module_spec">
    public static String component_conf[] = {
    	    "implementation_id", "iPhoneComm",
    	    "type_name",         "iPhoneComm",
    	    "description",       "Communicator for iPhone",
    	    "version",           "1.0.0",
    	    "vendor",            "N. Sato",
    	    "category",          "GU",
    	    "activity_type",     "STATIC",
    	    "max_instance",      "0",
    	    "language",          "Java",
    	    "lang_type",         "compile",
            // Configuration variables
            "conf.default.iPhoneURL", "192.168.1.30",
            "conf.default.iPhonePort", "57710",
            // Widget
            "conf.__widget__.iPhoneURL", "text",
            "conf.__widget__.iPhonePort", "text",
            // Constraints
    	    ""
            };
//  </rtc-template>

    public RTObject_impl createRtc(Manager mgr) {
        return new iPhoneCommImpl(mgr);
    }

    public void deleteRtc(RTObject_impl rtcBase) {
        rtcBase = null;
    }
    public void registerModule() {
        Properties prop = new Properties(component_conf);
        final Manager manager = Manager.instance();
        manager.registerFactory(prop, new iPhoneComm(), new iPhoneComm());
    }
}
